<template>
  <div class="app-container pageTopForm">
    <el-form :model="queryParams" ref="queryRef" size="small" v-show="showSearch" label-width="auto">
      <el-col :span="8">
        <el-form-item label="搜索" prop="switchName">
          <el-input
            v-model="queryParams.switchName"
            placeholder="请输入模版名称/资源组名/监控模版名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
      </el-col>
      <el-col :span="6">
        <el-form-item label="策略状态" prop="bandwidthType">
          <el-select
            v-model="queryParams.bandwidthType"
            placeholder="请选择策略状态"
            clearable>
            <el-option
              v-for="dict in dict.type.eps_bandwidth_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"/>
          </el-select>
        </el-form-item>
      </el-col>
      <el-col :span="6">
        <el-form-item class="lastBtnSty">
          <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
          <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-col>
    </el-form>
    <TableList :columns="columns" :config="config" :modelIdent="this.$options.name" :queryParams="queryParams" :tableList="tableList" @fnClick="callback" @fnRenderList="getList" @value-change="handleValueChange">
      <template #tempType="{ row, column }">
        <dict-tag :options="dict.type.rm_topology_type" :value="row.connectedDeviceType"/>
      </template>
    </TableList>
  </div>
</template>

<script setup>
  import TableList from "@/components/table/index.vue"
  import {listMonitorTemp, delMonitorTemp} from "@/api/disRevenue/resource"
  export default {
    name: 'AlarmManage',
    components: {TableList},
    dicts: ['rm_topology_type','eps_bandwidth_type'],
    data() {
      return {
        loading: true,
        showSearch: true,
        tableList: [],
        queryParams: {
          total: 0,
          pageNum: 1,
          pageSize: 10
        },
        // 列显隐信息
        columns: {
          id: { label: `ID`,width: '50'},
          switchName: { label: `策略名称`, minWidth: '250', visible: true },
          switchSn: { label: `描述`,minWidth: '200',visible: false},
          interfaceName: { label: `监关联资源组控项`,minWidth: '150', visible: true },
          serverName: { label: `包含设备`,minWidth: '200'},
          connectedDeviceType: { label: `关联监控模版`,minWidth: '150', visible: true },
          connected: { label: `策略内容`,minWidth: '200'},
          type: { label: `策略状态`, minWidth: '100', visible: true },
          conType: { label: `下发策略时间`,minWidth: '160'},
          createTime: { label: `创建时间`,minWidth: '160'},
          updateTime:{ label: `修改时间`,minWidth: '160'}
        },
        config: {
          searcherForm: [
            {label: '模版名称', prop: 'roleName', type: 'selset', options: []}
          ],
          tableButton: {
            top: [
              {content: '新增', fnCode: 'add', type: 'primary', icon: 'el-icon-plus', hasPermi: 'resource:alarmManage:add'},
              {content: '删除', fnCode: 'delete', type: 'danger', icon: 'el-icon-delete', hasPermi: 'resource:alarmManage:detele'},
              {content: '导出', fnCode: 'export', type: 'warning', icon: 'el-icon-download', hasPermi: 'resource:alarmManage:export'},
            ],
            line: [
              {content: '修改', fnCode: 'edit', type: 'text', icon: 'el-icon-edit', hasPermi: 'resource:alarmManage:edit'},
              {content: '详情', fnCode: 'details', type: 'text', icon: 'el-icon-view', hasPermi: 'resource:alarmManage:details'},
              {content: '复制', fnCode: 'copy', type: 'text', icon: 'el-icon-document-copy', hasPermi: 'resource:alarmManage:copy'},
              {content: '下发策略', fnCode: 'strategy', type: 'text', icon: 'el-icon-sort-down', hasPermi: 'resource:alarmManage:strategy'},
            ]
          }
        }
      }
    },
    created() {
      this.getList();
    },
    methods: {
      /** 查询列表 */
      getList() {
        this.loading = true;
        listMonitorTemp(this.queryParams).then(response => {
          this.tableList = response.rows;
          this.queryParams.total = response.total;
          this.loading = false;
        })
      },
      // 处理子组件传递的新值
      handleValueChange(newValue) {
        // 父组件更新自身数据，实现同步
        this.showSearch = newValue;
        // console.log('父组件拿到新值:', newValue);
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },

      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryRef");
        this.handleQuery();
      },

      callback(result, rowData, selectChange) {
        if (result && result.fnCode) {
          switch (result.fnCode) {
            case 'add':
              this.$router.push({
                path:'/resource/alarmManage/details'});
              break;
            case 'edit':
              this.$router.push({
                path:'/resource/alarmManage/details',
                query:{
                  id: rowData.id
                }
              });
              break;
            case 'details':
              // this.$router.push({
              //   path:'/disRevenue/resource/alarmManage/view/index',
              //   query:{
              //     id: rowData.id
              //   }
              // });
              break;
            case 'delete':
              this.$modal.confirm('是否确认删除数据项？').then(function() {
                return delMonitorTemp(selectChange)
              }).then(() => {
                this.getList();
                this.$modal.msgSuccess("删除成功")
              }).catch(() => {});
              break;
            case 'export':
              // let dataList = [];
              // Object.keys(this.columns).forEach(item => {
              //   if (item.visible) {
              //     dataList.push(item.prop);
              //   }
              // });
              // this.download("/system/alarmManage/export", {properties: dataList,}, `拓扑管理_${new Date().getTime()}.xlsx`);
              let paramsList = Object.assign({}, this.queryParams,rowData);
              this.download("system/alarmManage/export", paramsList, `资源监控策略_${new Date().getTime()}.xlsx`, null, 'json');
              break;
            default:
          }
        }
      }
    }
  }
</script>
<style scoped>
  ::v-deep .lastBtnSty .el-form-item__content{
    margin-left: 10px!important;
  }
</style>
